/*
** Highscore loading and saving routines for GamePark32
** Added by Andreas Gustafsson 030607
** sdw@lysator.liu.se
*/

#include <stdio.h>
#include <stdlib.h>
#include "gpdef.h"
#include "gpstdlib.h"
#include "gpstdio.h"
#include "game.h"

extern hscore_t game_hscores[8];

void ReadHiScores()
{
	F_HANDLE fi;
	unsigned long bytesRead=0;

	GpFatInit();		
	if(GpFileOpen("gp:\\GPMM\\XRICK.HIS",OPEN_R,&fi)==SM_OK)
	{
		if(GpFileRead(fi,game_hscores,sizeof(hscore_t)*8,&bytesRead)==SM_OK)
		{
			if(bytesRead!=sizeof(hscore_t)*8)
			{
				/* Error, reset scores?*/
			}
		}
		GpFileClose(fi);
	}
}

void WriteHiScores()
{
	F_HANDLE fi;

	if(GpFileCreate("gp:\\GPMM\\XRICK.HIS",ALWAYS_CREATE,&fi)!=SM_OK) return;
	if(GpFileOpen("gp:\\GPMM\\XRICK.HIS",OPEN_W,&fi)==SM_OK)
	{
		GpFileWrite(fi,game_hscores,sizeof(hscore_t)*8);
		GpFileClose(fi);
	}
}
