#include "system.h"
#include "game.h"
#include "screens.h"

#include "draw.h"
#include "control.h"

extern U16 game_start_map;

/*
 * Display XRICK main menu screen
 *
 * return: SCREEN_RUNNING, SCREEN_DONE, SCREEN_EXIT
 */
U8
screen_menu(void)
{
  	static U8 seq = 0;
  	static U8 redraw = 1;
  	static U8 cur_choice=0;
  	static U8 code_mode=0;
 	static U16 level_code_list[4]={0000,9040,6791,1756}; 	

	const U8	*gpmenutext1 = "\
@@@@@@@@@@@@@@XRICK32@V1.2@@@@@@@@@@@@@@\377\
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\377\
::::::::::::::::::::::::::::::::::::::::\377\
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\377\
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\377\
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\377\
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@\377\
@@@@@@@@@@@@@@@MAIN@MENU@@@@@@@@@@@@@@@@\377\
@@@@@@@@@@@@@@@:::::::::@@@@@@@@@@@@@@@@\376";

const U8	*gpmenutext2 = "\
::::::::::::::::::::::::::::::::::::::::\377\
@@@@@@GP32@PORT@BY@ANDERS@GRANLUND@@@@@@\377\
@HIGHSCORESAVER@AND@LEVEL@CODE@FEATURES@\377\
@@@@@@@@@BY@ANDREAS@GUSTAFSSON@@@@@@@@@@\376";

	static U8 *levelcodetext1= "@@@@@@@@@@@@LEVEL@CODE@0000@@@@@@@@@@@@@\376";
	static U8 *levelcodetext2= "@@@@@@@@@@<@LEVEL@CODE@0000@<@@@@@@@@@@@\376";
	static U16 level_code=0;
	static U8 code_digit[4]={0,0,0,0};
	static U8 cur_digit=0;

	if(seq==0)
	{
		redraw=1;
		level_code=level_code_list[game_start_map];
		code_digit[0]=level_code/1000;
		code_digit[1]=(level_code%1000)/100;
		code_digit[2]=(level_code%100)/10;
		code_digit[3]=(level_code%10);
	}
	if(redraw==1)
	{
		redraw=0;	
		sysvid_clear();    
		draw_tllst = (U8 *)gpmenutext1;
		draw_setfb(0, 0);
		draw_tilesList();
		draw_tllst = (U8 *)gpmenutext2;
		draw_setfb(0, 168);
		draw_tilesList();
		
		if(cur_choice==0)
		{
			if(game_start_map==0) draw_tllst=(U8*)"@@@@@@@<@START@GAME@AT@LEVEL@1@<@@@@@@@@\376";
			else if(game_start_map==1) draw_tllst=(U8*)"@@@@@@@<@START@GAME@AT@LEVEL@2@<@@@@@@@@\376";
			else if(game_start_map==2) draw_tllst=(U8*)"@@@@@@@<@START@GAME@AT@LEVEL@3@<@@@@@@@@\376";
			else if(game_start_map==3) draw_tllst=(U8*)"@@@@@@@<@START@GAME@AT@LEVEL@4@<@@@@@@@@\376";
		}
		else
		{
			if(game_start_map==0) draw_tllst=(U8*)"@@@@@@@@@START@GAME@AT@LEVEL@1@@@@@@@@@@\376";
			else if(game_start_map==1) draw_tllst=(U8*)"@@@@@@@@@START@GAME@AT@LEVEL@2@@@@@@@@@@\376";
			else if(game_start_map==2) draw_tllst=(U8*)"@@@@@@@@@START@GAME@AT@LEVEL@3@@@@@@@@@@\376";
			else if(game_start_map==3) draw_tllst=(U8*)"@@@@@@@@@START@GAME@AT@LEVEL@4@@@@@@@@@@\376";
		}
		draw_setfb(0, 48+24);
		draw_tilesList();
		if(cur_choice==1)
		{
			levelcodetext2[23]=code_digit[0]+'0';
			levelcodetext2[24]=code_digit[1]+'0';
			levelcodetext2[25]=code_digit[2]+'0';
			levelcodetext2[26]=code_digit[3]+'0';
			draw_tllst=levelcodetext2;
		}
		else
		{
			levelcodetext1[23]=code_digit[0]+'0';
			levelcodetext1[24]=code_digit[1]+'0';
			levelcodetext1[25]=code_digit[2]+'0';
			levelcodetext1[26]=code_digit[3]+'0';
			draw_tllst=levelcodetext1;
		}
		draw_setfb(0, 64+24);
		draw_tilesList();
		if(code_mode==1)
		{
			draw_tllst=(U8*)":\376";
			draw_setfb(23*8+cur_digit*8,72+24);
			draw_tilesList();
		}
		if(cur_choice==2)
		{
			draw_tllst=(U8*)"@@@@@@@@@@@@@<@RESET@GP32@<@@@@@@@@@@@@@\376";
		}
		else
		{
			draw_tllst=(U8*)"@@@@@@@@@@@@@@@RESET@GP32@@@@@@@@@@@@@@@\376";
		}
		draw_setfb(0, 80+24);
		draw_tilesList();
						
		game_rects = &draw_SCREENRECT;
	}
  switch (seq) 
  {
  		case 0:  /* make sure fire is released */
  			if(!(control_status & CONTROL_FIRE))
  			{
  				seq=1;
  			}
  		break;
  		case 1:  /* wait for input*/
  			if(control_status & CONTROL_FIRE)
  			{
  				if(cur_choice==1)
  				{  
  					if(code_mode==0)
  					{
  						cur_digit=0;
  					}					
  					if(code_mode==1)
  					{
  						level_code=code_digit[0]*1000;
  						level_code+=code_digit[1]*100;
  						level_code+=code_digit[2]*10;
  						level_code+=code_digit[3];
  						if(level_code==level_code_list[0]) game_start_map=0;
  						else if(level_code==level_code_list[1]) game_start_map=1;
  						else if(level_code==level_code_list[2]) game_start_map=2;
  						else if(level_code==level_code_list[3]) game_start_map=3;
  						else game_start_map=0;
  					}
  					code_mode=1-code_mode; /* toggle code entering mode on/off */
  				}
  				if(cur_choice==2) GpAppExit();
  				redraw=1;
  				seq=3;
  			}
  			else if(control_status & CONTROL_UP)
  			{
  				if(code_mode==0)
  				{
  					if(cur_choice>0) cur_choice--;
  				}
  				else
  				{
  					code_digit[cur_digit]++;
  					if(code_digit[cur_digit]==10) code_digit[cur_digit]=0;
  				}
  				redraw=1;
  				seq=4;
  			}
  			else if(control_status & CONTROL_DOWN)
  			{
  				if(code_mode==0)
  				{
  					if(cur_choice<2) cur_choice++;
  				}
  				else
  				{
  					code_digit[cur_digit]--;
  					if(code_digit[cur_digit]==255) code_digit[cur_digit]=9;
  				}
  				redraw=1;
  				seq=5;
  			}
  			else if(control_status & CONTROL_LEFT)
  			{  				
  				if(cur_digit>0) cur_digit--;
  				redraw=1;
  				seq=6;
  			}
  			else if(control_status & CONTROL_RIGHT)
  			{  				
  				if(cur_digit<3) cur_digit++;
  				redraw=1;
  				seq=7;
  			}
  		break;
  		case 3:  /* wait for fire release*/
  			if(!(control_status & CONTROL_FIRE))
  			{
  				if(cur_choice==0) seq=99; /* start game */
  				else seq=1;
  			}
   	break;
  		case 4:  /* wait for up release*/
  			if(!(control_status & CONTROL_UP))
  			{
  				seq=1;
  			}
   	break;
  		case 5:  /* wait for down release*/
  			if(!(control_status & CONTROL_DOWN))
  			{
  				seq=1;
  			}
   	break;
  		case 6:  /* wait for left release*/
  			if(!(control_status & CONTROL_LEFT))
  			{
  				seq=1;
  			}
   	break;
  		case 7:  /* wait for right release*/
  			if(!(control_status & CONTROL_RIGHT))
  			{
  				seq=1;
  			}
   	break;
  }

  if (control_status & CONTROL_EXIT)  /* check for exit request */
    return SCREEN_EXIT;

  if (seq == 99) 
  {  /* we're done */
    sysvid_clear();
    sysvid_setGamePalette();
    seq = 0;
    return SCREEN_DONE;
  }
  
  return SCREEN_RUNNING;
}

/* eof */

