/*
 * xrick/src/sysevt.c
 *
 * This source code file is part of the xrick distribution, and as such is
 * copyrighted. Please read the README file in the root directory of the
 * distribution for information about copyrights, trademarks, license,
 * disclaimers, etc.
 */

#include "system.h"
#include "game.h"
#include "debug.h"

#include "control.h"
#include "draw.h"

#define SYSJOY_RANGE 3280

/*
 * Process an event
 */
static void processEvent()
{
	int key;

	GpKeyGetEx( &key);

	// GP32 Soft-Reset
	if((key & GPC_VK_FL) && (key & GPC_VK_FR) && (key & GPC_VK_START) && (key & GPC_VK_SELECT))
		game_state = EXIT;

	// X-Rick input
    if ((key & syskbd_up) && !(control_status & CONTROL_UP)){
      control_status |= CONTROL_UP;
      control_last = CONTROL_UP;
    }
    else if ((key & syskbd_down) && !(control_status & CONTROL_DOWN)){
      control_status |= CONTROL_DOWN;
      control_last = CONTROL_DOWN;
    }
    else if ((key & syskbd_left) && !(control_status & CONTROL_LEFT)){
      control_status |= CONTROL_LEFT;
      control_last = CONTROL_LEFT;
    }
    else if ((key & syskbd_right) && !(control_status & CONTROL_RIGHT)){
      control_status |= CONTROL_RIGHT;
      control_last = CONTROL_RIGHT;
    }
    else if ((key & syskbd_pause) && !(control_status & CONTROL_PAUSE)){
      control_status |= CONTROL_PAUSE;
      control_last = CONTROL_PAUSE;
    }
    else if ((key & syskbd_end) && !(control_status & CONTROL_END)){
      control_status |= CONTROL_END;
      control_last = CONTROL_END;
    }
    else if ((key & syskbd_fire) && !(control_status & CONTROL_FIRE)){
      control_status |= CONTROL_FIRE;
      control_last = CONTROL_FIRE;
    }

	// Extended buttons for GP32 version
    else if ((key & syskbd_fire2) && !(control_status & CONTROL_FIRE2)){
      control_status |= CONTROL_FIRE2;
      control_last = CONTROL_FIRE2;
    }
    else if ((key & syskbd_fire3) && !(control_status & CONTROL_FIRE3)){
      control_status |= CONTROL_FIRE3;
      control_last = CONTROL_FIRE3;
    }


    else if (!(key & syskbd_up) && (control_status & CONTROL_UP)){
      control_status ^= CONTROL_UP;
      control_last = CONTROL_UP;
    }
    else if (!(key & syskbd_down) && (control_status & CONTROL_DOWN)){
      control_status ^= CONTROL_DOWN;
      control_last = CONTROL_DOWN;
    }
    else if (!(key & syskbd_left) && (control_status & CONTROL_LEFT)){
      control_status ^= CONTROL_LEFT;
      control_last = CONTROL_LEFT;
    }
    else if (!(key & syskbd_right) && (control_status & CONTROL_RIGHT)){
      control_status ^= CONTROL_RIGHT;
      control_last = CONTROL_RIGHT;
    }
    else if (!(key & syskbd_pause) && (control_status & CONTROL_PAUSE)){
      control_status ^= CONTROL_PAUSE;
      control_last = CONTROL_PAUSE;
    }
    else if (!(key & syskbd_end) && (control_status & CONTROL_END)){
      control_status ^= CONTROL_END;
      control_last = CONTROL_END;
    }
    else if (!(key & syskbd_fire) && (control_status & CONTROL_FIRE)){
      control_status ^= CONTROL_FIRE;
      control_last = CONTROL_FIRE;
    }

	// Extended buttons for GP32
    else if (!(key & syskbd_fire2) && (control_status & CONTROL_FIRE2)){
      control_status ^= CONTROL_FIRE2;
      control_last = CONTROL_FIRE2;
    }
    else if (!(key & syskbd_fire3) && (control_status & CONTROL_FIRE3)){
      control_status ^= CONTROL_FIRE3;
      control_last = CONTROL_FIRE3;
    }









/*
#ifdef ENABLE_CHEATS
    else if (key == SDLK_7) {
      game_toggleCheat(1);
    }
    else if (key == SDLK_8) {
      game_toggleCheat(2);
    }
    else if (key == SDLK_9) {
      game_toggleCheat(3);
    }
#endif
*/


}
  
/*
 * Process events, if any, then return
 */
void
sysevt_poll(void)
{
    processEvent();

}

/*
 * Wait for an event, then process it and return
 */
void
sysevt_wait(void)
{
  processEvent();
}

/* eof */



